-- RPATTER2.EXE    
-- A program to draw patterns based on a recursive algorithm
-- Mark K. Akita
-- 5/22/01
          
-------------------------------------------------------------

without type_check
include get.e
include graphics.e
include misc.e

constant FALSE=0,TRUE=1

sequence s1
integer done,i1,n,nr,ct1,ct2
object ret1

-- s1 = 4x4 pattern sequence
-------------------------------------------------------------

procedure init()
    
    integer rr,gg,bb,cc
    atom r
        
    n=rand(5)+1
    s1=repeat(repeat(0,n),n)
    for x=1 to n do
        for y=1 to n do
            s1[x][y]=rand(2)-1    
        end for
    end for
    
    r=640
    nr=0
    while r>1 do
        r /= n
        nr += 1    
    end while
    
    
    rr=rand(2)-1
    gg=rand(2)-1
    bb=rand(2)-1
    for i=0 to 15 do
        cc=i*4+3
        ret1=palette(i,{rr*cc,gg*cc,bb*cc})    
    end for
    if rr+gg+bb=0 then
        all_palette({
        {0,0,0},
        {63,0,0},
        {63,16,0},
        {63,32,0},
        {63,63,0},
        {32,63,0},
        {0,63,0},
        {0,63,16},
        {0,63,32},
        {0,63,63},
        {0,32,63},
        {0,0,63},
        {16,0,63},
        {32,0,63},
        {63,0,63},
        {63,0,32}
        })    
    end if

    ct1=rand(6)
    ct2=rand(6)

end procedure

-------------------------------------------------------------

procedure drawit(integer x, integer y, integer o, integer lv)

integer x1,y1,c

    if lv>1 then 
        for xx=1 to n do
            x1=(xx-1)*power(n,(lv-1))+x
            for yy=1 to n do
                y1=(yy-1)*power(n,(lv-1))+y
                if x1<641 and y1<481 then
                    if o then
                        drawit(x1,y1,s1[xx][yy],lv-1)
                    else
                        drawit(x1,y1,1-s1[xx][yy],lv-1)
                    end if
                end if
            end for
        end for
    else
        for xx=1 to n do
            for yy=1 to n do
                if o then
                    if s1[xx][yy] then
                        if ct1=1 then
                            c=floor(sin((x+xx)/10)*7+8)
                        end if
                        if ct1=2 then
                            c=floor(sin((y+yy)/10)*7+8)
                        end if
                        if ct1=3 then
                            c=remainder(x+xx,15)+1
                        end if
                        if ct1=4 then
                            c=remainder(y+yy,15)+1
                        end if
                        if ct1=5 then
                            c=remainder((x+xx)*(y+yy),15)+1
                        end if
                        if ct1=6 then
                            c=remainder((x+xx)+(y+yy),15)+1
                        end if
                        pixel(c,{xx+x-1,yy+y-1})        
                    else
                        pixel(0,{xx+1-1,yy+y-1})        
                    end if
                else                
                    if s1[xx][yy] then
                        pixel(0,{x+x-1,yy+y-1})        
                    else
                        if ct2=1 then
                            c=floor(sin((x+xx)/10)*7+8)
                        end if
                        if ct2=2 then
                            c=floor(sin((y+yy)/10)*7+8)
                        end if
                        if ct2=3 then
                            c=remainder(x+xx,15)+1
                        end if
                        if ct2=4 then
                            c=remainder(y+yy,15)+1
                        end if
                        if ct2=5 then
                            c=remainder((x+xx)*(y+yy),15)+1
                        end if
                        if ct2=6 then
                            c=remainder((x+xx)+(y+yy),15)+1
                        end if
                        pixel(c,{xx+x-1,yy+y-1})        
                    end if
                end if
            end for
        end for
    end if
    
end procedure

-------------------------------------------------------------
                                                                 
-- Set Graphics to 640x480x16color
ret1=graphics_mode(18)
                                                                                
  
done=FALSE

while not done do
    clear_screen()                                                                  
    init()

    drawit(1,1,1,nr)

    sleep(8)
--Test for a key
    i1 = get_key()
    if i1!=-1 then
        done = TRUE
    end if      

end while

ret1=graphics_mode(-1)
 
 

