-- TREES2.EXE    
-- A program to draw trees based on a recursive algorithm
-- Mark K. Akita
-- 5/14/01
          
-------------------------------------------------------------

without type_check
include get.e
include graphics.e
include misc.e

constant FALSE=0,TRUE=1

integer sh,sw,lb,lt,nb,bt,lw,nl,nl2
integer done,i1
atom sa,wr,mina,maxa
object ret1

-- sa = starting angle
-- sh = starting height
-- sw = starting width
-- nr = number of recursions
-- bt = branch test
-- nb = number of branches
-- nl = number of leaves
-- mina = minimum branch angle
-- maxa = maximum branch angle
-- wr = width ratio
-- lb = leaf base
-- lw = leaf width
-- lt = leaf top
-- nl2 = number of leaves 2
-------------------------------------------------------------

procedure init()
    
    sw=rand(9)+5
    sh=rand(3)+5
    nb=rand(4)
    nl=rand(4)
    bt=rand(9)+8
    mina=(rand(2000)-1000)/1000
    maxa=(rand(1000)-500)/1000
    wr=(rand(3)+14)/100        
    lb=rand(4)+1
    lt=lb+rand(6)
    lw=rand(5)
    nl2=rand(4)
    sa=-PI/2
    
end procedure

-------------------------------------------------------------

procedure drawlf(atom x,atom y,atom a)
    atom dx,dy,a1,a2,x1,x2,x3,x4,y1,y2,y3,y4

    
    for i=1 to rand(nl2) do
        x=x+rand(10)-5
        y=y+rand(10)-5
        x1=x
        y1=y
        a1=a+(PI/2)
        a2=a-(PI/2)       
        dx=x+cos(a)*2
        dy=y+sin(a)*2
        x2=dx+cos(a1)*lw
        y2=dy+sin(a1)*lw
        x4=dx+cos(a2)*lw
        y4=dy+sin(a2)*lw
        x3=x+cos(a)*lt
        y3=y+sin(a)*lt
        polygon(rand(7)+8,TRUE,{{x1,y1},{x2,y2},{x3,y3},{x4,y4}})

    end for

end procedure

-------------------------------------------------------------

procedure drawit(atom x,atom y,atom w,integer h,atom a,integer lv)

    atom dx,dy,dw,a1,a2,x1,x2,x3,x4,y1,y2,y3,y4,na
    integer cnt,c2
    
    cnt=0

    if lv<1 then 
        lv=1     
    end if

    while w>.3 do
        a1=a+(PI/2)
        a2=a-(PI/2)    
        x1=x+cos(a1)*w
        y1=y+sin(a1)*w
        x2=x+cos(a2)*w
        y2=y+sin(a2)*w
        if rand(10)>7 then
            a=a+((rand(600)-300)/1000)
        end if
        a1=a+(PI/2)
        a2=a-(PI/2)    
        dx=x+cos(a)*h
        dy=y+sin(a)*h
        dw=w-wr
        x3=dx+cos(a2)*dw
        y3=dy+sin(a2)*dw
        x4=dx+cos(a1)*dw
        y4=dy+sin(a1)*dw
        if rand(10)>5 then
            polygon(lv,TRUE,{{x1,y1},{x2,y2},{x3,y3},{x4,y4}})
        else
            c2=lv+rand(3)-1
            if c2>7 then
                c2=7    
            end if
            if c2<1 then
                c2=1    

            end if
            polygon(c2,TRUE,{{x1,y1},{x2,y2},{x3,y3},{x4,y4}})
        end if
        x=dx
        y=dy
        w=dw
        cnt=cnt+1
        if cnt>bt then
            for i=1 to rand(nb) do
                na=(rand(2000)-1000)/1000
                if na>0 then
                    na=a+(mina+na*maxa)
                else    
                    na=a-(mina-na*maxa)
                end if
                drawit(x,y,w,h,a,lv-1)
            end for
            cnt=0
        end if
        if w<sw/2 then
            for i=1 to rand(nl) do
                na=(rand(2000)-1000)/1000
                if na>0 then
                    na=a+(mina+na*maxa)
                else    
                    na=a-(mina-na*maxa)
                end if
                drawlf(x,y,na)
            end for
        end if
    end while
    
end procedure

-------------------------------------------------------------
                                                                 
-- Set Graphics to 640x480x16color
ret1=graphics_mode(18)
                                                                                
  
done=FALSE

while not done do
    clear_screen()                                                                  
    init()

    if rand(2)>1 then
        all_palette({{55,55,63},{16,17,12},{18,18,12},{22,19,12},{26,20,12},{27,21,12},
        {28,22,12},{29,23,12},{30,24,12},{0,48,16},{0,48,8},{0,48,0},{8,48,0},{16,48,0},
        {32,48,0},{0,32,24}})
    else    
        all_palette({{63,55,55},{16,17,12},{18,18,12},{22,19,12},{26,20,12},{27,21,12},
        {28,22,12},{29,23,12},{30,24,12},{48,48,0},{52,48,0},{58,24,0},{63,14,0},{48,32,0},
        {48,38,0},{63,48,0}})
    end if

    drawit(320,479,sw,sh,sa,8)

    sleep(10)
--Test for a key
    i1 = get_key()
    if i1!=-1 then
        done = TRUE
    end if      

end while

ret1=graphics_mode(-1)
 

